Index: trunk/src/lib/network/monitor/network_node.cc
===================================================================
--- trunk/src/lib/network/monitor/network_node.cc	(revision 9406)
+++ trunk/src/lib/network/monitor/network_node.cc	(revision 9406)
@@ -0,0 +1,270 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Patrick Boenzli
+*/
+
+
+#include "network_node.h"
+
+#include "debug.h"
+
+
+/**
+ * constructor
+ */
+NetworkNode::NetworkNode(PeerInfo* pInfo)
+{
+  this->playerNumber = 0;
+  this->peerInfo = pInfo;
+}
+
+
+/**
+ * deconstructor
+ */
+NetworkNode::~NetworkNode()
+{}
+
+
+/**
+ * adds a client
+ */
+void NetworkNode::addClient(PeerInfo* node)
+{
+  this->clientList.push_back(node);
+  this->playerNumber++;
+  this->connectionNumber++;
+}
+
+/**
+ * adds a proxy server
+ */
+void NetworkNode::addActiveProxyServer(PeerInfo* node)
+{
+  this->activeProxyServerList.push_back(node);
+  this->connectionNumber++;
+}
+
+/**
+ * adds a proxy server
+ */
+void NetworkNode::addPassiveProxyServer(PeerInfo* node)
+{
+  this->passiveProxyServerList.push_back(node);
+}
+
+/**
+ * adds a master server
+ */
+void NetworkNode::addMasterServer(PeerInfo* node)
+{
+  this->masterServerList.push_back(node);
+  this->playerNumber++;
+}
+
+/**
+ * removes a client
+ */
+void NetworkNode::removeClient(PeerInfo* node)
+{
+  std::list<PeerInfo*>::iterator it = this->clientList.begin();
+  for(; it != this->clientList.end(); it++)
+  {
+    if( *it == node)
+    {
+      this->clientList.erase(it);
+      this->playerNumber--;
+      return;
+    }
+  }
+
+  PRINTF(2)("Could not remove client from the list, very strange...");
+}
+
+/**
+ * removes a proxy server
+ */
+void NetworkNode::removeActiveProxyServer(PeerInfo* node)
+{
+  std::list<PeerInfo*>::iterator it = this->activeProxyServerList.begin();
+  for(; it != this->activeProxyServerList.end(); it++)
+  {
+    if( *it == node)
+    {
+      this->activeProxyServerList.erase(it);
+      this->playerNumber--;
+      return;
+    }
+  }
+
+  PRINTF(2)("Could not remove proxy server from the list, very strange...");
+}
+
+/**
+ * removes a proxy server
+ */
+void NetworkNode::removePassiveProxyServer(PeerInfo* node)
+{
+  std::list<PeerInfo*>::iterator it = this->passiveProxyServerList.begin();
+  for(; it != this->passiveProxyServerList.end(); it++)
+  {
+    if( *it == node)
+    {
+      this->passiveProxyServerList.erase(it);
+      return;
+    }
+  }
+
+  PRINTF(2)("Could not remove proxy server from the list, very strange...");
+}
+
+/**
+ * removes a master server
+ */
+void NetworkNode::removeMasterServer(PeerInfo* node)
+{
+  std::list<PeerInfo*>::iterator it = this->masterServerList.begin();
+  for(; it != this->masterServerList.end(); it++)
+  {
+    if( *it == node)
+    {
+      this->masterServerList.erase(it);
+      this->playerNumber--;
+      return;
+    }
+  }
+
+  PRINTF(2)("Could not remove client from the list, very strange...");
+}
+
+
+/**
+ * @param index index to the client
+ * @return the client in the list or NULL if none
+ */
+PeerInfo* NetworkNode::getClient(int index)
+{
+  if( this->clientList.size() < index)
+    return NULL;
+
+  std::list<PeerInfo*>::iterator it = this->clientList.begin();
+  for(int i = 0; it != this->clientList.end(); it++, i++)
+  {
+  if( i == index)
+    return (*it);
+  }
+
+  return NULL;
+}
+
+
+/**
+ * @param index index to the client
+ * @return the active proxy server in the list or NULL if none
+ */
+PeerInfo* NetworkNode::getActiveProxyServer(int index)
+{
+  if( this->activeProxyServerList.size() < index)
+    return NULL;
+
+  std::list<PeerInfo*>::iterator it = this->activeProxyServerList.begin();
+  for(int i = 0; it != this->activeProxyServerList.end(); it++, i++)
+  {
+    if( i == index)
+      return (*it);
+  }
+
+  return NULL;
+}
+
+
+/**
+ * @param index index to the client
+ * @return the passive proxy server in the list or NULL if none
+ */
+PeerInfo* NetworkNode::getPassiveProxyServer(int index)
+{
+  if( this->passiveProxyServerList.size() < index)
+    return NULL;
+
+  std::list<PeerInfo*>::iterator it = this->passiveProxyServerList.begin();
+  for(int i = 0; it != this->passiveProxyServerList.end(); it++, i++)
+  {
+    if( i == index)
+      return (*it);
+  }
+
+  return NULL;
+}
+
+
+/**
+ * @param index index to the client
+ * @return the master server in the list or NULL if none
+ */
+PeerInfo* NetworkNode::getMasterServer(int index)
+{
+  if( this->masterServerList.size() < index)
+    return NULL;
+
+  std::list<PeerInfo*>::iterator it = this->masterServerList.begin();
+  for(int i = 0; it != this->masterServerList.end(); it++, i++)
+  {
+    if( i == index)
+      return (*it);
+  }
+
+  return NULL;
+}
+
+
+/**
+ * debug function
+ * @param depth: depth in the tree
+ */
+void NetworkNode::debug(int depth)
+{
+  PRINT(0)(" = %s\n", this->peerInfo->getNodeTypeString().c_str());
+
+  PRINT(0)("    master servers: %i\n", this->masterServerList.size());
+  std::list<PeerInfo*>::iterator it = this->masterServerList.begin();
+  for(; it != this->masterServerList.end(); it++)
+  {
+    IP* ip = &(*it)->ip;
+    PRINT(0)("     - ms, id: %i (%s)\n", (*it)->userId, ip->ipString().c_str());
+  }
+
+  PRINT(0)("    proxy servers active: %i\n", this->activeProxyServerList.size());
+  it = this->activeProxyServerList.begin();
+  for(; it != this->activeProxyServerList.end(); it++)
+  {
+    IP* ip = &(*it)->ip;
+    PRINT(0)("     - ps-a, id: %i (%s)\n", (*it)->userId, ip->ipString().c_str());
+  }
+
+  PRINT(0)("    proxy servers passive: %i\n", this->passiveProxyServerList.size());
+  it = this->passiveProxyServerList.begin();
+  for(; it != this->passiveProxyServerList.end(); it++)
+  {
+    IP* ip = &(*it)->ip;
+    PRINT(0)("     - ps-p, id: %i (%s)\n", (*it)->userId, ip->ipString().c_str());
+  }
+
+  PRINT(0)("    clients: %i\n", this->clientList.size());
+  it = this->clientList.begin();
+  for(; it != this->clientList.end(); it++)
+  {
+    IP* ip = &(*it)->ip;
+    PRINT(0)("     - client, id: %i (%s)\n", (*it)->userId, ip->ipString().c_str());
+  }
+}
+
Index: trunk/src/lib/network/monitor/network_node.h
===================================================================
--- trunk/src/lib/network/monitor/network_node.h	(revision 9406)
+++ trunk/src/lib/network/monitor/network_node.h	(revision 9406)
@@ -0,0 +1,72 @@
+/*!
+ * @file network_node.h
+ *  a class representing a node in the network (this can be a MASTER_SERVER, PROXY_SERVER or a CLIENT
+ */
+
+#ifndef _NETWORK_NODE_H
+#define _NETWORK_NODE_H
+
+#include "base_object.h"
+#include "synchronizeable.h"
+#include "peer_info.h"
+
+#include <list>
+
+
+//!< a class representing a node in the network (this can be a MASTER_SERVER, PROXY_SERVER or a CLIENT
+class NetworkNode
+{
+  public:
+    NetworkNode(PeerInfo* pInfo);
+    ~NetworkNode();
+
+
+    void addClient(PeerInfo* node);
+    void addActiveProxyServer(PeerInfo* node);
+    void addPassiveProxyServer(PeerInfo* node);
+    void addMasterServer(PeerInfo* node);
+
+    void removeClient(PeerInfo* node);
+    void removeActiveProxyServer(PeerInfo* node);
+    void removePassiveProxyServer(PeerInfo* node);
+    void removeMasterServer(PeerInfo* node);
+
+    PeerInfo* getClient(int index);
+    PeerInfo* getActiveProxyServer(int index);
+    PeerInfo* getPassiveProxyServer(int index);
+    PeerInfo* getMasterServer(int index);
+
+    /** @returns the master server list */
+    inline std::list<PeerInfo*> getMasterServer() { return this->masterServerList; }
+    /** @returns the active proxy server list */
+    inline std::list<PeerInfo*> getActiveProxyServer() { return this->activeProxyServerList; }
+    /** @returns the passive proxy server list */
+    inline std::list<PeerInfo*> getPassiveProxyServer() { return this->passiveProxyServerList; }
+    /** @returns the client list */
+    inline std::list<PeerInfo*> getClient() { return this->clientList; }
+
+
+    /** @returns the number of players */
+    inline int getPlayerNumber() { return this->playerNumber; }
+    /** @returns the node type of this node */
+    inline int getNodeType() { return this->peerInfo->nodeType; }
+    /** @returns the peer info of this node */
+    inline PeerInfo* getPeerInfo() { return this->peerInfo; }
+
+    void debug(int depth);
+
+
+  private:
+    int                          playerNumber;                 //!< localy direct connected player number
+    int                          connectionNumber;             //!< number of connections ( can but musn't be equal players)
+    PeerInfo*                    peerInfo;                     //!< the peer informationa about this node
+
+    /* network nodes directly connected to this node */
+    std::list<PeerInfo*>         clientList;                   //!< list of all clients in the network
+    std::list<PeerInfo*>         activeProxyServerList;        //!< list of all proxy servers in the network
+    std::list<PeerInfo*>         passiveProxyServerList;       //!< list of all proxy servers in the network
+    std::list<PeerInfo*>         masterServerList;             //!< list of all master servers in the network (should be 1!! :D)
+
+};
+
+#endif /* _NETWORK_NODE_H */
Index: trunk/src/lib/network/netdefs.h
===================================================================
--- trunk/src/lib/network/netdefs.h	(revision 9391)
+++ trunk/src/lib/network/netdefs.h	(revision 9406)
@@ -1,32 +1,55 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
 
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Christoph Renner rennerc@ee.ethz.ch
+   co-programmer:   Patrick Boenzli  boenzlip@orxonox.ethz.ch
+
+     June 2006: finishing work on the network stream for pps presentation (rennerc@ee.ethz.ch)
+     July 2006: some code rearangement and integration of the proxy server mechanism (boenzlip@ee.ethz.ch)
+*/
 
 /*!
  * @file network_manager.h
  *  Main interface for the network module. Manages all the modules
-
  */
 
-#ifndef _NETDEFS
-#define _NETDEFS
+#ifndef _NETDEFS_H
+#define _NETDEFS_H
 
-#ifdef HAVE_SDL_NET_H
-  #include <SDL_net.h>
-#else
-  #include <SDL/SDL_net.h>
-#endif
+#include "nettypes.h"
+#include "netincl.h"
 
 
-#define MAX_CONNECTIONS 1000
 
+//!< the amount of slots used before a proxy server is activated
+#define NET_CONNECTION_SATURATION 0.75
+
+//!< network polling frequency
 #define NETWORK_FREQUENCY 66
 
 
-typedef unsigned char byte;
+//!< orxonox protocol id
+#define _ORXONOX_ID        0xF91337A0
+//!< orxonox network version identifier
+#define _ORXONOX_VERSION   1
 
 
 //!< enum indicating the type of the node
 typedef enum {
-  NET_SERVER,
-  NET_CLIENT
+  NET_MASTER_SERVER,
+  NET_PROXY_SERVER_ACTIVE,
+  NET_PROXY_SERVER_PASSIVE,
+  NET_CLIENT,
+
+  NET_NR_TYPES
+
 } NodeType;
 
@@ -44,3 +67,3 @@
 } UidType;
 
-#endif /* _NETWORK_MANAGER */
+#endif /* _NETDEFS_H */
Index: trunk/src/lib/network/netincl.h
===================================================================
--- trunk/src/lib/network/netincl.h	(revision 9406)
+++ trunk/src/lib/network/netincl.h	(revision 9406)
@@ -0,0 +1,12 @@
+
+#ifndef _NETINCL_H
+#define _NETINCL_H
+
+#ifdef HAVE_SDL_NET_H
+#include <SDL_net.h>
+#else
+#include <SDL/SDL_net.h>
+#endif
+
+
+#endif /* _NETINCL_H */
Index: trunk/src/lib/network/nettypes.h
===================================================================
--- trunk/src/lib/network/nettypes.h	(revision 9406)
+++ trunk/src/lib/network/nettypes.h	(revision 9406)
@@ -0,0 +1,7 @@
+
+#ifndef __NET_TYPES_H_
+#define __NET_TYPES_H_
+
+typedef unsigned char byte;
+
+#endif /* __NET_TYPES_H */
Index: trunk/src/lib/network/network_game_manager.cc
===================================================================
--- trunk/src/lib/network/network_game_manager.cc	(revision 9391)
+++ trunk/src/lib/network/network_game_manager.cc	(revision 9406)
@@ -10,12 +10,13 @@
 
 ### File Specific:
-   main-programmer: Benjamin Wuest
-   co-programmer: ...
+   main-programmer: Christoph Renner rennerc@ee.ethz.ch
+   co-programmer:   Patrick Boenzli  boenzlip@orxonox.ethz.ch
+
+     June 2006: finishing work on the network stream for pps presentation (rennerc@ee.ethz.ch)
+     July 2006: some code rearangement and integration of the proxy server mechanism (boenzlip@ee.ethz.ch)
 */
 
 
-/* this is for debug output. It just says, that all calls to PRINT() belong to the DEBUG_MODULE_NETWORK module
-   For more information refere to https://www.orxonox.net/cgi-bin/trac.cgi/wiki/DebugOutput
-*/
+
 #define DEBUG_MODULE_NETWORK
 
@@ -45,6 +46,5 @@
 
 
-/* using namespace std is default, this needs to be here */
-using namespace std;
+
 
 NetworkGameManager* NetworkGameManager::singletonRef = NULL;
@@ -62,9 +62,9 @@
 
   this->setSynchronized(true);
-  
+
   MessageManager::getInstance()->registerMessageHandler( MSGID_DELETESYNCHRONIZEABLE, delSynchronizeableHandler, NULL );
   MessageManager::getInstance()->registerMessageHandler( MSGID_PREFEREDTEAM, preferedTeamHandler, NULL );
   MessageManager::getInstance()->registerMessageHandler( MSGID_CHATMESSAGE, chatMessageHandler, NULL );
-  
+
   this->gameState = 0;
   registerVar( new SynchronizeableInt( &gameState, &gameState, "gameState" ) );
@@ -77,7 +77,7 @@
 {
   delete MessageManager::getInstance();
-  
+
   PlayerStats::deleteAllPlayerStats();
-  
+
   NetworkGameManager::singletonRef = NULL;
 }
@@ -86,15 +86,15 @@
 /**
  * insert new player into game
- * @param userId 
- * @return 
+ * @param userId
+ * @return
  */
 bool NetworkGameManager::signalNewPlayer( int userId )
 {
-  assert( SharedNetworkData::getInstance()->isGameServer() );
+  assert( SharedNetworkData::getInstance()->isMasterServer() ||  SharedNetworkData::getInstance()->isProxyServer());
   assert( State::getGameRules() );
   assert( State::getGameRules()->isA( CL_NETWORK_GAME_RULES ) );
-  
+
   NetworkGameRules & rules = *(dynamic_cast<NetworkGameRules*>(State::getGameRules()));
-  
+
   int team = rules.getTeamForNewUser();
   ClassID playableClassId = rules.getPlayableClassId( userId, team );
@@ -102,36 +102,36 @@
   std::string playableTexture = rules.getPlayableModelFileName( userId, team, playableClassId );
   float       playableScale = rules.getPlayableScale( userId, team, playableClassId );
-  
+
   BaseObject * bo = Factory::fabricate( playableClassId );
-  
+
   assert( bo != NULL );
   assert( bo->isA( CL_PLAYABLE ) );
-  
+
   Playable & playable = *(dynamic_cast<Playable*>(bo));
-  
+
   playable.loadMD2Texture( playableTexture );
-  
+
   playable.loadModel( playableModel, 100.0f );
   playable.setOwner( userId );
   playable.setUniqueID( SharedNetworkData::getInstance()->getNewUniqueID() );
   playable.setSynchronized( true );
-  
+
   PlayerStats * stats = rules.getNewPlayerStats( userId );
-  
+
   stats->setUniqueID( SharedNetworkData::getInstance()->getNewUniqueID() );
   stats->setSynchronized( true );
   stats->setOwner( SharedNetworkData::getInstance()->getHostID() );
-  
+
   stats->setTeamId( team );
   stats->setPlayableClassId( playableClassId );
   stats->setPlayableUniqueId( playable.getUniqueID() );
   stats->setModelFileName( playableModel );
-  
+
   if ( userId == 0 )
     stats->setNickName( Preferences::getInstance()->getString( "multiplayer", "nickname", "Server" ) );
-  
+
   if ( rules.isA( CL_MULTIPLAYER_TEAM_DEATHMATCH ) )
     dynamic_cast<MultiplayerTeamDeathmatch*>(&rules)->respawnPlayable( &playable, team, 0.0f );
-  
+
   return true;
 }
@@ -140,6 +140,6 @@
 /**
  * remove player from game
- * @param userID 
- * @return 
+ * @param userID
+ * @return
  */
 bool NetworkGameManager::signalLeftPlayer(int userID)
@@ -151,5 +151,5 @@
     delete PlayerStats::getStats( userID );
   }
-  
+
   return true;
 }
@@ -159,22 +159,22 @@
 /**
  * handler for remove synchronizeable messages
- * @param messageId 
- * @param data 
- * @param dataLength 
- * @param someData 
- * @param userId 
+ * @param messageId
+ * @param data
+ * @param dataLength
+ * @param someData
+ * @param userId
  * @return true on successfull handling else handler will be called again
  */
 bool NetworkGameManager::delSynchronizeableHandler( MessageId messageId, byte * data, int dataLength, void * someData, int userId )
 {
-  if ( getInstance()->isServer() )
+  if ( SharedNetworkData::getInstance()->isMasterServer() ||  SharedNetworkData::getInstance()->isProxyServer())
   {
     PRINTF(2)("Recieved DeleteSynchronizeable message from client %d!\n", userId);
     return true;
   }
-  
+
   int uniqueId = 0;
   int len = Converter::byteArrayToInt( data, &uniqueId );
-  
+
   if ( len != dataLength )
   {
@@ -182,7 +182,7 @@
     return true;
   }
-  
+
   const std::list<BaseObject*> * list = ClassList::getList( CL_SYNCHRONIZEABLE );
-  
+
   for ( std::list<BaseObject*>::const_iterator it = list->begin(); it != list->end(); it++ )
   {
@@ -194,10 +194,10 @@
         return true;
       }
-      
+
       delete dynamic_cast<Synchronizeable*>(*it);
       return true;
     }
   }
-  
+
   return true;
 }
@@ -210,5 +210,5 @@
 {
   byte buf[INTSIZE];
-  
+
   assert( Converter::intToByteArray( uniqueId, buf, INTSIZE ) == INTSIZE );
 
@@ -220,18 +220,18 @@
 /**
  * handler for MSGID_PREFEREDTEAM message
- * @param messageId 
- * @param data 
- * @param dataLength 
- * @param someData 
- * @param userId 
- * @return 
+ * @param messageId
+ * @param data
+ * @param dataLength
+ * @param someData
+ * @param userId
+ * @return
  */
 bool NetworkGameManager::preferedTeamHandler( MessageId messageId, byte * data, int dataLength, void * someData, int userId )
 {
-  assert( NetworkGameManager::getInstance()->isServer() );
-  
+  assert( SharedNetworkData::getInstance()->isMasterServer() ||  SharedNetworkData::getInstance()->isProxyServer());
+
   int teamId = 0;
   int len = Converter::byteArrayToInt( data, &teamId );
-  
+
   if ( len != dataLength )
   {
@@ -239,7 +239,7 @@
     return true;
   }
-  
+
   NetworkGameManager::getInstance()->setPreferedTeam( userId, teamId );
-  
+
   return true;
 }
@@ -249,7 +249,7 @@
   if ( !PlayerStats::getStats( userId ) )
     return;
-  
+
   PlayerStats & stats = *(PlayerStats::getStats( userId ));
-  
+
   stats.setPreferedTeamId( teamId );
 }
@@ -257,16 +257,16 @@
 /**
  * set prefered team for this host
- * @param teamId 
+ * @param teamId
  */
 void NetworkGameManager::prefereTeam( int teamId )
 {
-  if ( isServer() )
+  if ( SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer())
     setPreferedTeam( SharedNetworkData::getInstance()->getHostID(), teamId );
   else
   {
     byte buf[INTSIZE];
-    
+
     assert( Converter::intToByteArray( teamId, buf, INTSIZE) == INTSIZE );
-    
+
     MessageManager::getInstance()->sendMessage( MSGID_PREFEREDTEAM, buf, INTSIZE, RT_USER, 0, MP_HIGHBANDWIDTH );
   }
@@ -285,8 +285,8 @@
     {
       const std::list<BaseObject*> * list = ClassList::getList( CL_PLAYABLE );
-       
+
       if ( list && std::find( list->begin(), list->end(), *it ) != list->end() )
-      {      
-        PRINTF(0)("Delete unused playable: %s owner: %d\n", (*it)->getClassName(), (*it)->getOwner() );
+      {
+        PRINTF(0)("Delete unused playable: %s owner: %d\n", (*it)->getClassCName(), (*it)->getOwner() );
         std::list<Playable*>::iterator delit = it;
         it++;
@@ -305,21 +305,21 @@
 {
   PRINTF(0)("NetworkGameManager::chatMessageHandler %d %d\n", userId, SharedNetworkData::getInstance()->getHostID() );
-  if ( NetworkGameManager::getInstance()->isServer() && userId !=  SharedNetworkData::getInstance()->getHostID() )
+  if ( (SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer()) && userId !=  SharedNetworkData::getInstance()->getHostID() )
   {
     MessageManager::getInstance()->sendMessage( messageId, data, dataLength, RT_ALL_NOT_ME, 0, MP_HIGHBANDWIDTH );
   }
-  
+
   assert( State::getGameRules() );
   assert( State::getGameRules()->isA( CL_NETWORK_GAME_RULES ) );
-  
+
   NetworkGameRules & rules = *(dynamic_cast<NetworkGameRules*>(State::getGameRules()));
-  
+
   if ( dataLength < 3*INTSIZE )
   {
     PRINTF(2)("got too small chatmessage from client %d\n", userId);
-    
+
     return true;
   }
-  
+
   int messageType = 0;
   Converter::byteArrayToInt( data, &messageType );
@@ -328,5 +328,5 @@
   std::string message;
   Converter::byteArrayToString( data+2*INTSIZE, message, dataLength-2*INTSIZE );
-  
+
   rules.handleChatMessage( senderUserId, message, messageType );
 
@@ -346,11 +346,11 @@
   assert( Converter::intToByteArray( SharedNetworkData::getInstance()->getHostID(), buf+INTSIZE, INTSIZE ) == INTSIZE );
   assert( Converter::stringToByteArray(message, buf+2*INTSIZE, message.length()+INTSIZE) == message.length()+INTSIZE );
-  
-  if ( this->isServer() )
+
+  if ( SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer())
     MessageManager::getInstance()->sendMessage( MSGID_CHATMESSAGE, buf, message.length()+3*INTSIZE, RT_ALL_ME, 0, MP_HIGHBANDWIDTH );
   else
     MessageManager::getInstance()->sendMessage( MSGID_CHATMESSAGE, buf, message.length()+3*INTSIZE, RT_ALL_NOT_ME, 0, MP_HIGHBANDWIDTH );
 
-  
+
   delete [] buf;
 }
Index: trunk/src/lib/network/network_game_manager.h
===================================================================
--- trunk/src/lib/network/network_game_manager.h	(revision 9391)
+++ trunk/src/lib/network/network_game_manager.h	(revision 9406)
@@ -28,6 +28,4 @@
   NET_YOU_ARE_ENTITY,
   NET_REQUEST_ENTITY_LIST,
-  NET_REQUEST_PNODE_PATH,
-  NET_SEND_PNODE_PATH,
 
   NET_NUMBER
@@ -42,11 +40,12 @@
 
 /*!
- * a class that can create and remove entities
+ * a class that can create and remove entities over the network
  */
 class NetworkGameManager: public Synchronizeable
 {
+
   public:
     virtual ~NetworkGameManager();
-    
+
     static NetworkGameManager* NetworkGameManager::getInstance()
     { if (!NetworkGameManager::singletonRef) NetworkGameManager::singletonRef = new NetworkGameManager(); return NetworkGameManager::singletonRef; }
@@ -55,29 +54,32 @@
     bool signalNewPlayer( int userId );
     bool signalLeftPlayer( int userID );
-    
-    void removeSynchronizeable( int uniqueId );
-    
+
     void prefereTeam( int teamId );
+
 
     inline void setGameState( int gameState ){ this->gameState = gameState; }
     inline int getGameState(){ return this->gameState; }
-    
+
     void tick( float ds );
-    
+
+    void removeSynchronizeable( int uniqueId );
     void sendChatMessage( const std::string & message, int messageType );
+
 
   private:
     NetworkGameManager();
-    
+
     static bool delSynchronizeableHandler( MessageId messageId, byte * data, int dataLength, void * someData, int userId );
     static bool preferedTeamHandler( MessageId messageId, byte * data, int dataLength, void * someData, int userId );
     static bool chatMessageHandler( MessageId messageId, byte * data, int dataLength, void * someData, int userId );
-    
+
     void setPreferedTeam( int userId, int teamId );
 
+
+  private:
     static NetworkGameManager*    singletonRef;
-    
+
     int                           gameState;
-    
+
     std::list<Playable*>          playablesToDelete;
 };
Index: trunk/src/lib/network/network_manager.cc
===================================================================
--- trunk/src/lib/network/network_manager.cc	(revision 9391)
+++ trunk/src/lib/network/network_manager.cc	(revision 9406)
@@ -10,6 +10,6 @@
 
    ### File Specific:
-   main-programmer: Patrick Boenzli
-   co-programmer: ...
+   main-programmer: Patrick Boenzli (patrick@orxonox.ethz.ch)
+   co-programmer: Christoph Renner (rennerc@ee.ethz.ch)
 */
 
@@ -34,5 +34,5 @@
 
 /* using namespace std is default, this needs to be here */
-using namespace std;
+
 
 SHELL_COMMAND(debug, NetworkManager, debug);
@@ -53,8 +53,8 @@
   this->networkStream = NULL;
   this->elapsedTime = 0.0f;
-  
-    
+
+
   int port = Preferences::getInstance()->getInt( "network", "telnetport", 0 );
-  
+
   if ( port > 0 )
     NetworkLog::getInstance()->listen( port );
@@ -75,5 +75,5 @@
     this->networkStream = NULL;
   }
-  
+
   NetworkManager::singletonRef = NULL;
 }
@@ -95,4 +95,54 @@
 {
 
+}
+
+
+
+/**
+ *  creates a new NetworkStream of server type
+ * @param port: number of the TCP port
+ */
+int NetworkManager::createMasterServer(unsigned int port)
+{
+  // load the network settings
+  NetworkSettings::getInstance()->loadData();
+
+  // create the network stream
+  this->networkStream = new NetworkStream(NET_MASTER_SERVER);
+  this->networkStream->createServer( port);
+
+  // start the network game manager
+  this->networkStream->createNetworkGameManager();
+
+  PRINTF(0)("Created Network Master Server\n");
+  SDL_Delay(20);
+  return 1;
+}
+
+/**
+ *  creates a new network stream of proxy server type
+ * @param port: number of the TCP port
+ */
+int NetworkManager::createProxyServer(unsigned int port)
+{
+  // load the network settings
+  NetworkSettings::getInstance()->loadData();
+
+  // create the network stream
+  this->networkStream = new NetworkStream(NET_PROXY_SERVER_ACTIVE);
+  this->networkStream->createServer( port);
+  // and connect to the master server for synchronization
+//   this->networkStream->connectToMasterServer(NetworkSettings::getInstance()->getMasterAddr());
+  // and to the other proxy servers
+
+
+
+  // start the network game manager
+  this->networkStream->createNetworkGameManager();
+
+
+  PRINTF(0)("Created Network Proxy Server\n");
+  SDL_Delay(20);
+  return 1;
 }
 
@@ -102,9 +152,18 @@
  * @param hostName: the name of the destination host
  */
-int NetworkManager::establishConnection(const std::string & name, unsigned int port)
-{
-  this->networkStream = new NetworkStream( name, port );
-  SharedNetworkData::getInstance()->setDefaultSyncStream(this->networkStream);
+int NetworkManager::createClient(const std::string & name, unsigned int port)
+{
+  // load the network settings
+  NetworkSettings::getInstance()->loadData();
+
+  // create the network stream
+  this->networkStream = new NetworkStream(NET_CLIENT);
+  // connect to the master server, if a redirection should occure, this is handled in the NetworkStream itself
+  this->networkStream->connectToMasterServer( name, port);
+
+  // and start the handshake
   this->networkStream->startHandshake();
+
+  PRINTF(0)("Created Network Client");
   return 1;
 }
@@ -112,20 +171,7 @@
 
 /**
- *  creates a new NetworkStream of server type
- * @param port: number of the TCP port
- */
-int NetworkManager::createServer(unsigned int port)
-{
-  SharedNetworkData::getInstance()->setHostID(0);
-  SharedNetworkData::getInstance()->setGameServer(true);
-  this->networkStream = new NetworkStream(port);
-  SharedNetworkData::getInstance()->setDefaultSyncStream(this->networkStream);
-  this->networkStream->createNetworkGameManager();
-  PRINTF(0)("CREATE SERVER\n");
-  SDL_Delay(20);
-  return 1;
-}
-
-
+ * connects a synchronizeable to the network stream
+ * @param sync: synchronizeable to connect
+ */
 void NetworkManager::connectSynchronizeable(Synchronizeable& sync)
 {
@@ -144,9 +190,10 @@
   if( likely(this->elapsedTime < 1.0f / NETWORK_FREQUENCY))
     return;
+
   this->elapsedTime = 0.0f;
 
-  if ( networkStream )
+  if ( this->networkStream )
     networkStream->processData();
-  
+
   NetworkGameManager::getInstance()->tick( this->elapsedTime );
 }
Index: trunk/src/lib/network/network_manager.h
===================================================================
--- trunk/src/lib/network/network_manager.h	(revision 9391)
+++ trunk/src/lib/network/network_manager.h	(revision 9406)
@@ -36,11 +36,7 @@
     void shutdown();
 
-    int establishConnection( const std::string & name, unsigned int port);
-    int createServer(unsigned int port);
-
-    /** Returns the hostID @return The hostID of the object */
-    inline int getHostID() { return SharedNetworkData::getInstance()->getHostID(); }
-    inline bool isGameServer() { return SharedNetworkData::getInstance()->isGameServer(); }
-
+    int createClient( const std::string & name, unsigned int port);
+    int createMasterServer( unsigned int port);
+    int createProxyServer( unsigned int port);
 
     void connectSynchronizeable(Synchronizeable& sync);
@@ -56,5 +52,5 @@
   private:
     static NetworkManager*           singletonRef;            //!< Pointer to the only instance of this Class
-    NetworkStream*                   networkStream;       //!< pointer to network stream
+    NetworkStream*                   networkStream;           //!< pointer to network stream
 
     float                            elapsedTime;             //!< elapsed time since the last network update
Index: trunk/src/lib/network/network_protocol.cc
===================================================================
--- trunk/src/lib/network/network_protocol.cc	(revision 9391)
+++ trunk/src/lib/network/network_protocol.cc	(revision 9406)
@@ -33,5 +33,5 @@
 
 /* using namespace std is default, this needs to be here */
-using namespace std;
+
 
 
Index: trunk/src/lib/network/network_socket.cc
===================================================================
--- trunk/src/lib/network/network_socket.cc	(revision 9391)
+++ trunk/src/lib/network/network_socket.cc	(revision 9406)
@@ -33,4 +33,6 @@
 {
   bOk = true;
+  this->ip.host = 0;
+  this->ip.port = 0;
 }
 
Index: trunk/src/lib/network/network_socket.h
===================================================================
--- trunk/src/lib/network/network_socket.h	(revision 9391)
+++ trunk/src/lib/network/network_socket.h	(revision 9406)
@@ -27,9 +27,19 @@
      */
     virtual void connectToServer( std::string host, int port ) = 0;
-    
+
     /**
      * disconnect from server
      */
     virtual void disconnectServer() = 0;
+
+    /**
+     * reconnecting to another server by terminating old connection and init a new connection
+     */
+    virtual void reconnectToServer( std::string host, int port) = 0;
+
+    /**
+     * reconnecting to anoter server softly
+     */
+    virtual void reconnectToServerSoft( std::string host, int port) = 0;
 
     /**
@@ -40,5 +50,5 @@
      */
     virtual bool writePacket(byte * data, int length) = 0;
-    
+
     /**
      * read a packet sent by another NetworkSocket
@@ -54,8 +64,13 @@
      */
     inline bool isOk() { return this->bOk; }
-  
+
+    /** @returns the ip adderess of the destination socket */
+    IPaddress getRemoteAddress() { return ip; }
+
+
   protected:
-    bool bOk;            //!< check for socket status
+    bool              bOk;            //!< check for socket status
 
+    IPaddress         ip;             //!< host,port
 };
 
